-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zp21-package_carregar_dimensions_dwh.log
-----------------------------------------
-----------------------------------------

CREATE OR REPLACE PACKAGE pfc_DWH.CARREGA_DIMENSIONS AS
    PROCEDURE PR_CARREGA_D_CATEGORIES;
    PROCEDURE PR_CARREGA_D_CENTRES;
    PROCEDURE PR_CARREGA_D_EMPRESES;
    PROCEDURE PR_CARREGA_D_MARQUES;
    PROCEDURE PR_CARREGA_D_MODELS;
	PROCEDURE PR_CARREGA_D_EQUIPS;
	PROCEDURE PR_CARREGA_D_TIPUS_PRIORITAT;
    PROCEDURE PR_CARREGA_D_TIPUS_MANTENIMENT;
	PROCEDURE PR_CARREGA_D_TIPUS_REPARACIO;
	PROCEDURE PR_CARREGA_D_TIPUS_REVISIO;	
    PROCEDURE PR_CARREGA_D_TRAMS_ANTIGUITAT;
	PROCEDURE PR_CARREGA_D_ANYS;
	PROCEDURE PR_CARREGA_D_MESOS;		
END;
/

CREATE OR REPLACE PACKAGE BODY pfc_DWH.CARREGA_DIMENSIONS AS

    PROCEDURE PR_CARREGA_D_CATEGORIES AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_CATEGORIES;
	  COMMIT;
      INSERT INTO D_CATEGORIES 
		SELECT *
		FROM pfc_ODS.D_CATEGORIES; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_D_CENTRES AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_CENTRES;
	  COMMIT;
      INSERT INTO D_CENTRES 
		SELECT *
		FROM pfc_ODS.D_CENTRES; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
    PROCEDURE PR_CARREGA_D_EMPRESES AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_EMPRESES;
	  COMMIT;
      INSERT INTO D_EMPRESES 
		SELECT *
		FROM pfc_ODS.D_EMPRESES; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_D_MARQUES AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_MARQUES;
	  COMMIT;
      INSERT INTO D_MARQUES 
		SELECT *
		FROM pfc_ODS.D_MARQUES; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	
	
    PROCEDURE PR_CARREGA_D_MODELS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_MODELS;
	  COMMIT;
      INSERT INTO D_MODELS 
		SELECT *
		FROM pfc_ODS.D_MODELS; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_D_EQUIPS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_EQUIPS;
	  COMMIT;
      INSERT INTO D_EQUIPS 
		SELECT *
		FROM pfc_ODS.D_EQUIPS; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;		

    PROCEDURE PR_CARREGA_D_TIPUS_PRIORITAT AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_TIPUS_PRIORITAT;
	  COMMIT;
      INSERT INTO D_TIPUS_PRIORITAT 
		SELECT *
		FROM pfc_ODS.D_TIPUS_PRIORITAT; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_D_TIPUS_MANTENIMENT AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_TIPUS_MANTENIMENT;
	  COMMIT;
      INSERT INTO D_TIPUS_MANTENIMENT 
		SELECT *
		FROM pfc_ODS.D_TIPUS_MANTENIMENT; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_D_TIPUS_REPARACIO AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_TIPUS_REPARACIO;
	  COMMIT;
      INSERT INTO D_TIPUS_REPARACIO 
		SELECT *
		FROM pfc_ODS.D_TIPUS_REPARACIO; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_D_TIPUS_REVISIO AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_TIPUS_REVISIO;
	  COMMIT;
      INSERT INTO D_TIPUS_REVISIO 
		SELECT *
		FROM pfc_ODS.D_TIPUS_REVISIO; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	
	
    PROCEDURE PR_CARREGA_D_TRAMS_ANTIGUITAT AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_TRAMS_ANTIGUITAT;
	  COMMIT;
      INSERT INTO D_TRAMS_ANTIGUITAT 
		SELECT *
		FROM pfc_ODS.D_TRAMS_ANTIGUITAT; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_D_ANYS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_ANYS;
	  COMMIT;
      INSERT INTO D_ANYS 
		SELECT *
		FROM pfc_ODS.D_ANYS; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_D_MESOS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM D_MESOS;
	  COMMIT;
      INSERT INTO D_MESOS 
		SELECT *
		FROM pfc_ODS.D_MESOS; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

END;
/
COMMIT;


spool off
exit
