-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zp23-package_carregar_fets_dwh.log
-----------------------------------------
-----------------------------------------

CREATE OR REPLACE PACKAGE pfc_DWH.CARREGA_FETS AS
    PROCEDURE PR_CARREGA_F_EQUIPS_INSTALLATS;
    PROCEDURE PR_CARREGA_F_MANTENIMENTS;
    PROCEDURE PR_CARREGA_F_REVISIONS;
    PROCEDURE PR_CARREGA_F_TEMPS_RESOLUCIO;
    PROCEDURE PR_CARREGA_F_REPARACIONS;
END;
/

CREATE OR REPLACE PACKAGE BODY pfc_DWH.CARREGA_FETS AS

    PROCEDURE PR_CARREGA_F_EQUIPS_INSTALLATS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM F_EQUIPS_INSTALLATS;
	  COMMIT;
      INSERT INTO F_EQUIPS_INSTALLATS 
		SELECT *
		FROM pfc_ODS.F_EQUIPS_INSTALLATS; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_F_MANTENIMENTS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM F_MANTENIMENTS;
	  COMMIT;
      INSERT INTO F_MANTENIMENTS 
		SELECT *
		FROM pfc_ODS.F_MANTENIMENTS; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;
	
    PROCEDURE PR_CARREGA_F_REVISIONS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM F_REVISIONS;
	  COMMIT;
      INSERT INTO F_REVISIONS 
		SELECT *
		FROM pfc_ODS.F_REVISIONS; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_F_TEMPS_RESOLUCIO AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM F_TEMPS_RESOLUCIO;
	  COMMIT;
      INSERT INTO F_TEMPS_RESOLUCIO 
		SELECT *
		FROM pfc_ODS.F_TEMPS_RESOLUCIO; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;

    PROCEDURE PR_CARREGA_F_REPARACIONS AS
    BEGIN
	  --esborrem i tornem a carregar
      DELETE FROM F_REPARACIONS;
	  COMMIT;
      INSERT INTO F_REPARACIONS 
		SELECT *
		FROM pfc_ODS.F_REPARACIONS; 
	  COMMIT;
	EXCEPTION 
     WHEN NO_DATA_FOUND THEN 
       NULL; 
     WHEN OTHERS THEN 
       RAISE; 	  
    END;	
	
END;
/
COMMIT;


spool off
exit