-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\ac1-creacio_schema_bdr.log
-----------------------------------------
-----------------------------------------

-- Connectat com SYSTEM
DROP TABLESPACE TS_BDR INCLUDING CONTENTS AND DATAFILES;
COMMIT;

-- tornem a crear
CREATE TABLESPACE TS_BDR
	DATAFILE 'C:\UOC\PFC\mbernard\DATA\BDR.DBF' SIZE 50 M 
	AUTOEXTEND ON
	LOGGING ONLINE PERMANENT
	EXTENT MANAGEMENT LOCAL AUTOALLOCATE
	BLOCKSIZE 8 K
	SEGMENT SPACE MANAGEMENT AUTO;
COMMIT;

DROP USER pfc_BDR CASCADE;
COMMIT;
CREATE USER pfc_BDR
	IDENTIFIED BY bdr
	DEFAULT TABLESPACE TS_BDR
	QUOTA UNLIMITED ON TS_BDR
	TEMPORARY TABLESPACE temp
	QUOTA 0 ON users;
COMMIT;

GRANT CREATE SESSION
      , CREATE TABLE
      , CREATE TRIGGER
      , CREATE SEQUENCE 
TO pfc_BDR;

GRANT CREATE PROCEDURE TO pfc_BDR;
GRANT CREATE SYNONYM TO pfc_BDR;
GRANT CREATE TYPE TO pfc_BDR;
COMMIT;



DROP USER pfc_BDR_user CASCADE;
COMMIT;
CREATE USER pfc_BDR_user
	IDENTIFIED BY bdr_user
	DEFAULT TABLESPACE TS_BDR
	QUOTA UNLIMITED ON TS_BDR
	TEMPORARY TABLESPACE temp
	QUOTA 0 ON users;
COMMIT;

GRANT CREATE SESSION
TO pfc_BDR_user;
COMMIT;



spool off
exit

