-----------------------------------------
-----------------------------------------
SET SERVEROUTPUT ON;
spool C:\UOC\PFC\mbernard\logs\ar1-carrega_dades.log
--SET echo ON
-----------------------------------------
-----------------------------------------

---------------------------------------------------
---------------------------------------------------
--connectat com a PFC_BDR
ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIMESTAMP_FORMAT = 'DD/MM/YYYY HH24:MI:SS';
ALTER SESSION SET NLS_TIME_FORMAT = 'HH24:MI:SS';
COMMIT;

---------------------------------------------------
--------------  POBLACIONS  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Barcelona', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Montcada i Reixac', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Badalona', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Sant Cugat del Valles', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Madrid', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Hospitalet de Llobregat', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Cornella', res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Bilbao', res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Valencia', res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Malaga', res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_POBLACIO ('Girona', res);
  DBMS_OUTPUT.PUT_LINE(res);    
END;
/

---------------------------------------------------
--------------  USUARIS  --------------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('mbernard','1bx12g2','46511111A','M Luisa Bernard','mbernard@empresa.com', 'ADMINISTRADOR',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('lgarcia','1ba12g2','46511112B','Luis Garcia','lgarcia@empresa.com', 'REFERENT',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('dflores','1bx1ag2','46511113A','David Flores','dflores@empresa.com', 'REFERENT',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('lmartinez','1bx12a2','46511114F','Luis Martinez','lmartinez@empresa.com', 'REFERENT',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('rfernandez','1bx12ga','46511115B','Ral Fernandez','rfernandez@empresa.com','REFERENT',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('crubio','2bx12ga','43511445B','Carme Rubio','crubio@empresa.com','LOGISTIC',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('pnebot','1bx45ga','46511335B','Pilar Nebot','pnebot@empresa.com','ANALISTA',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_USUARI('xhernandez','4fx88ga','46511225B','Xavi Hernandez','xhernandez@empresa.com','REFERENT',res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/

---------------------------------------------------
--------------  PRIORITATS  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_PRIORITAT('URGENT',1, res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_PRIORITAT('PREFERENT',3, res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_AUXILIAR.PR_ALTA_PRIORITAT('ORDINARIA',5, res); 
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/

---------------------------------------------------
-----------------  CENTRES  ------------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 1','manso 19',1,'08023','931234567','centre1@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 2','manso 88',1,'08023','931234589','centre2@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 3','calabria 8',2,'08223','982234589','centre3@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 4','industria 19',1,'08032','931234567','centre4@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 5','numancia 88',1,'08003','931234589','centre5@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 6','balmes 20',1,'08223','982234589','centre6@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 7','muntaner 19',1,'08023','933454567','centre7@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 8','sants 188',7,'08023','941234589','centre8@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 9','tarragona 8',2,'08223','982234584','centre9@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 10','girona 54',1,'08023','933334567','centre10@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 11','lepanto 80',1,'08023','934434589','centre11@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_CENTRES.PR_ALTA_CENTRE('Centre 12','urgell 12',2,'08223','982211589','centre12@empresa.com', res); 
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/

---------------------------------------------------
-----------------  EMPRESES  ----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('PC City','H45634534D','Casanovas 15',1,'08012','934555555','934555556', NULL,'resp@pccity.com','Luis Garcia','934555557','luisgarcia@pccity.com','902101101',res); 
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Carrefour','H45111111D','Llacuna 155',1,'08023','932455555',NULL, NULL,'resp@carrefour.com','Maria Perez','932455557','mperez@carrefour.com','902202202',res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Corte Ingls Can Drag','H2222D','Pg. Andreu Nin, 51',1,'08011', '932451111',NULL,NULL,'resp@corteingles.com','Antonio Carmona', '932451117','acarmona48@corteingles.com','902303303',res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('HP Sant Cugat','A45634534D','Cami de Can Graells, no. 1-21',4,'08174', '934455555',NULL,'935821400','resp@hp.com','Luis Martinez','934455557','lmartinez@hp.com','902027020',res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Xerox Espaa','BBBB555YTD','Ribera del Loira, 16-18',5,'28042', '902 200 169',NULL,'915 203 321','resp@xerox.com','M Jose Alcaraz','902 200 171','mariajose.alcaraz@xerox.com', '902200200',res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Toshiba Europe GmbH Sucursal en Espaa','BBB1111YTD','Parque Empresarial San Fernando Edificio Europa',5,'28830','91 660 6700','91 660 6701','91 660 6707','toshiba@toshiba.es', 'Ramon Guardia','91 660 6702','rguardia@xerox.com','91 660 6703',res); 
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Instafoc Barcelona SL','A1111YTD','Indstria, 331',1,'08027','93 408 08 80',NULL,'93 408 24 68','info@extintoresbarcelona.com','Victor Gil','93 408 08 81','vgil@extintoresbarcelona.com','902902902',res); 
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EMPRESES.PR_ALTA_EMPRESA('Ascensores Rubori S.A.','ZZA1111YTD','Ventall 17-19',1,'08025','934578967',NULL,'93 207 67 92','rubori@rubori.com',NULL,NULL,NULL,NULL,res); 
  DBMS_OUTPUT.PUT_LINE(res); 
END;
/
  
---------------------------------------------------
-----------------  OPERARI  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(1,'34567',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(1,'22120',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(3,'A00223',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(3,'A00225',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(3,'A00228',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(1,'1226',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(4,'C000012B',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(4,'C000022B',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(4,'C000034B',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(7,'A1',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EMPRESES.PR_ALTA_OPERARI(8,'OTIS000034',res);
  DBMS_OUTPUT.PUT_LINE(res); 
END;
/

---------------------------------------------------
--------------  CATEGORIES  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('caldera', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('aire condicionat', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('extintor', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('ordinador', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('fotocopiadora', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('impressora', res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('pantalla', res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_CATEGORIA('ascensor', res);
  DBMS_OUTPUT.PUT_LINE(res); 
END;
/

---------------------------------------------------
-------------------  MARCA  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('HP', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Toshiba', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Xerox', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Dell', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('ABC', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Canon', res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Otis', res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Liebherr', res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Packard', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Asus', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Benq', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('LG', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Philips', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Acer', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Lenovo', res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MARCA('Kensington', res);
  DBMS_OUTPUT.PUT_LINE(res);  
END;
/

---------------------------------------------------
-------------------  MODEL  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(1,'SyncMaster 902N','plana 19 pulgades',7,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(4,'E170S','plana 17 pulgades',7,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(4,'E2210 serie E','plana 17 pulgades',7,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(1,'LaserJet Pro CP1025 Color','laser, color',6,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(1,'LaserJet P2035','laser, blanco y negro',6,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(1,'Omni 200-5430es','taula',4,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(1,'Pavilion p6-2003es','taula, w7, AMD A4-3400, 6GB memoria',4,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(3,'iGen4 EXP','multifuncio',5,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(2,'NB520 10P','Disco duro 250 GB, Microsoft Windows 7 Starter',4,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(5,'pols ABC','25kg',3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EQUIPS.PR_ALTA_MODEL(7,'Gen 2 Premier','Sistema de rescate. Proteccin de acceso LAMBDA. Sistema PULSE. Sistema REM de monitorizacin',8,res);
  DBMS_OUTPUT.PUT_LINE(res); 
END;
/

---------------------------------------------------
-------------------  EQUIP  -----------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG567',7,4,1,'PC PLANTA 2 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG568',7,4,1,'PC PLANTA 2 - AULA 2','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG569',7,4,1,'PC PLANTA 2 - AULA 3','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG570',7,4,1,'PC PLANTA 2 - AULA 4','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG571',7,4,1,'PC PLANTA 2 - AULA 5','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG572',7,4,1,'PC PLANTA 2 - AULA 6','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG573',7,4,1,'PC PLANTA 2 - AULA 7','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG574',7,4,1,'PC PLANTA 2 - AULA 8','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG576',7,4,1,'PC PLANTA 2 - AULA 9','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG523',7,4,1,'PC PLANTA 1 - AULA 1','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG524',7,4,1,'PC PLANTA 1 - AULA 2','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG525',7,4,1,'PC PLANTA 1 - AULA 3','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG526',7,4,1,'PC PLANTA 1 - AULA 4','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG527',7,4,1,'PC PLANTA 1 - AULA 5','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG528',7,4,1,'PC PLANTA 1 - AULA 6','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG529',7,4,1,'PC PLANTA 1 - AULA 7','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG530',7,4,1,'PC PLANTA 1 - AULA 8','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG532',7,4,1,'PC PLANTA 1 - AULA 9','01/05/2010','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('AAAAA367',8,5,1,'FOTOCOPIADORA PTA BAIXA','23/03/2006','23/03/2008',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('OCQ367345FG',9,4,1,'portatil formacio','11/11/2009','11/11/2010',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('OCQ367345AA',9,4,1,'portatil direccio','11/11/2009','11/11/2010',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('BBBBBBB367',4,6,1,'impressora PTA BAIXA despatx 2','23/03/2007','23/03/2008',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('ABB367456',10,3,1,'extintor pta 1','23/03/2007','23/03/2010',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('ABB367457',10,3,1,'extintor pta 2','23/03/2007','23/03/2010',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG517',7,4,2,'PC PLANTA 2 - AULA 1','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG518',7,4,2,'PC PLANTA 2 - AULA 2','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG519',7,4,2,'PC PLANTA 2 - AULA 3','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG520',7,4,2,'PC PLANTA 2 - AULA 4','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG521',7,4,2,'PC PLANTA 2 - AULA 5','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG522',7,4,2,'PC PLANTA 2 - AULA 6','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG583',7,4,2,'PC PLANTA 2 - AULA 7','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG584',7,4,2,'PC PLANTA 2 - AULA 8','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG586',7,4,2,'PC PLANTA 2 - AULA 9','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG533',7,4,2,'PC PLANTA 1 - AULA 1','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG534',7,4,2,'PC PLANTA 1 - AULA 2','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG535',7,4,2,'PC PLANTA 1 - AULA 3','01/05/2006','01/05/2012',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG536',7,4,2,'PC PLANTA 1 - AULA 4','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG537',7,4,2,'PC PLANTA 1 - AULA 5','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG538',7,4,2,'PC PLANTA 1 - AULA 6','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG539',7,4,2,'PC PLANTA 1 - AULA 7','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG540',7,4,2,'PC PLANTA 1 - AULA 8','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('N34567RTG542',7,4,2,'PC PLANTA 1 - AULA 9','01/05/2006','01/05/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('AAAAA368',8,5,2,'FOTOCOPIADORA PTA BAIXA','23/03/2006','23/03/2008',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('OCQ367445FG',9,4,2,'portatil formacio','11/11/2006','11/11/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('OCQ367445AA',9,4,2,'portatil direccio','11/11/2006','11/11/2007',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('BBBBBBB365',4,6,1,'impressora PTA BAIXA despatx 1','23/03/2007','23/03/2008',res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('ABB367446',10,3,2,'extintor pta 1','23/03/2006','23/03/2010',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('ABB367447',10,3,2,'extintor pta 2','23/03/2006','23/03/2010',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('ASCXXXXXX1',11,8,1,'ascensor dreta','23/03/2004','23/03/2010',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('ASCXXXXXX2',11,8,1,'ascensor esquerra','23/03/2003','23/03/2010',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('ASCXXXXXX3',11,8,2,'ascensor dreta','23/03/2003','23/03/2010',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_EQUIPS.PR_ALTA_EQUIP('ASCXXXXXX4',11,8,2,'ascensor esquerra','23/03/2003','23/03/2010',res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/  

---------------------------------------------------
------------  MANTENIMENTS CORRECTIUS  ------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(5,'08/09/2010','pita quan s encn i el SO no es carrega',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(1,'11/06/2010','no s encn',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(2,'08/09/2010','problemes ventilador',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(50,'08/09/2011','es queda aturat entre 2 pisos amb gent a dins',2,1,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(50,'08/10/2011 11:00','la porta no tanca b',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(2,'08/01/2011','no s encn',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'08/01/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'13/02/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'08/03/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'28/03/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'08/04/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'13/05/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'08/06/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'13/07/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'08/09/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'13/11/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_CORRECTIU(22,'12/12/2011','el paper s enganxa en el rodet',2,3,res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/ 

---------------------------------------------------
-------------  RESOLUCIO MANTENIMENT  -------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(5,1,3,5,'08/09/2010','15/09/2010','canvi de ram',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(1,1,3,5,'12/06/2010','14/06/2010','canvi de placa',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(50,1,8,11,'08/09/2011','08/09/2011','engranatge',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(2,1,3,5,'08/09/2010','10/09/2010',null,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(2,2,3,5,'09/01/2011','12/01/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);    
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(50,2,8,11,'08/10/2011 15:00','10/10/2011','engranatge',res);
  DBMS_OUTPUT.PUT_LINE(res);  
  --11
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,1,3,5,'08/01/2011','08/01/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,2,3,5,'13/02/2011','13/02/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);    
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,3,3,5,'08/03/2011','08/03/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,4,3,5,'28/03/2011','30/03/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,5,3,5,'08/04/2011','08/04/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,6,3,5,'13/05/2011','14/05/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);    
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,7,3,5,'08/06/2011','12/06/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,8,3,5,'13/07/2011','17/07/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,9,3,5,'08/09/2011','12/09/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_RESOLUCIO_MANTCORR(22,10,3,5,'13/11/2011','17/11/2011',null,res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/ 

---------------------------------------------------
---------  MANTENIMENTS  PREVENTIUS  --------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(23,'23/03/2007','23/03/2014',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(24,'23/03/2007','23/03/2014',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(47,'23/03/2006','23/04/2008',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(48,'23/03/2006','23/04/2008',12,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(47,'24/04/2008','23/04/2012',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(48,'24/04/2008','23/04/2012',12,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(49,'23/03/2004','23/03/2009',12,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(49,'24/03/2009','24/03/2015',6,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(50,'23/03/2003','22/03/2004',6,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_MANT_PREVENTIU(51,'23/05/2011','22/05/2018',6,res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/ 

---------------------------------------------------
----------------  REVISIO  ------------------------
---------------------------------------------------
DECLARE
  res VARCHAR2(20000);
BEGIN
  --realitzem les revisions pendents inserides automticament
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(23,1,1,'23/03/2008','28/03/2008',7,10,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(24,1,1,'23/03/2008','28/03/2008',7,10,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(47,1,1,'23/03/2007','20/03/2007',7,10,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(48,1,1,'23/03/2007','20/03/2007',7,10,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(47,2,1,'23/04/2009','25/04/2009',7,10,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(48,2,1,'23/04/2009','25/04/2009',7,10,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(49,1,1,'23/03/2005','22/03/2005',8,11,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(49,2,1,'24/09/2009','22/09/2009',8,11,'oli maquinaria',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_MODIF_REVISIO_MANTPREV(50,3,1,'23/09/2003','22/09/2003',8,11,'oli maquinaria',NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  --inserim les revisions peridiques que falten 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(23,1,'28/03/2009','30/03/2009',7,10,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(23,1,'30/03/2010','02/04/2010',7,10,'canvi arandela',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(23,1,'02/04/2011','05/04/2011',7,10,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(23,1,'05/04/2012',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(24,1,'28/03/2009','30/03/2009',7,10,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(24,1,'30/03/2010','02/04/2010',7,10,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(24,1,'02/04/2011','05/04/2011',7,10,'canvi arandela',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(24,1,'05/04/2012',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(47,1,'20/03/2008','18/03/2008',7,10,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(47,2,'25/04/2010','21/04/2010',7,10,'canvi arandela',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(47,2,'21/04/2011','21/04/2011',7,10,'canvi arandela',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(47,2,'21/04/2012',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(48,1,'20/03/2008','18/03/2008',7,10,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(48,2,'25/04/2010','21/04/2010',7,10,'canvi arandela',res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(48,2,'21/04/2011','21/04/2011',7,10,'canvi arandela',res);
  DBMS_OUTPUT.PUT_LINE(res); 
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(48,2,'21/04/2012',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(49,1,'22/03/2006','28/03/2006',8,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(49,1,'28/03/2007','26/03/2007',8,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(49,1,'26/03/2008','23/03/2009',8,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(49,2,'22/03/2010','23/03/2010',8,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(49,2,'23/09/2010','22/09/2010',8,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(49,2,'22/03/2011','23/03/2011',8,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);  
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(49,2,'23/09/2011','24/09/2011',8,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(49,2,'24/03/2012',NULL,NULL,NULL,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);
  pfc_BDR.PKG_MANTENIMENTS.PR_ALTA_REVISIO_MANTPREV(50,3,'22/03/2004','20/03/2004',8,11,NULL,res);
  DBMS_OUTPUT.PUT_LINE(res);   
END;
/ 


spool off
SET SERVEROUTPUT OFF
exit