-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zc11-creacio_schema_ods.log
-----------------------------------------
-----------------------------------------

-- Connectat com SYSTEM
DROP TABLESPACE TS_ODS INCLUDING CONTENTS AND DATAFILES;
COMMIT;

-- tornem a crear el ts
CREATE TABLESPACE TS_ODS
	DATAFILE 'C:\UOC\PFC\mbernard\DATA\ODS.DBF' SIZE 50 M 
	AUTOEXTEND ON
	LOGGING ONLINE PERMANENT
	EXTENT MANAGEMENT LOCAL AUTOALLOCATE
	BLOCKSIZE 8 K
	SEGMENT SPACE MANAGEMENT AUTO;
COMMIT;

DROP USER pfc_ODS CASCADE;
COMMIT;

CREATE USER pfc_ODS
	IDENTIFIED BY ods
	DEFAULT TABLESPACE TS_ODS
	QUOTA UNLIMITED ON TS_ODS
	TEMPORARY TABLESPACE temp
	QUOTA 0 ON users;
COMMIT;

GRANT CREATE SESSION
      , CREATE TABLE
      , CREATE TRIGGER
      , CREATE SEQUENCE 
TO pfc_ODS;

GRANT CREATE PROCEDURE TO pfc_ODS;
GRANT CREATE SYNONYM TO pfc_ODS;
COMMIT;

spool off
exit
