-----------------------------------------
-----------------------------------------
spool C:\UOC\PFC\mbernard\logs\zc12-creacio_schema_dwh.log
-----------------------------------------
-----------------------------------------

-- Connectat com SYSTEM
DROP TABLESPACE TS_DWH INCLUDING CONTENTS AND DATAFILES;
COMMIT;

-- tornem a crear
CREATE TABLESPACE TS_DWH
	DATAFILE 'C:\UOC\PFC\mbernard\DATA\DWH.DBF' SIZE 50 M 
	AUTOEXTEND ON
	LOGGING ONLINE PERMANENT
	EXTENT MANAGEMENT LOCAL AUTOALLOCATE
	BLOCKSIZE 8 K
	SEGMENT SPACE MANAGEMENT AUTO;
COMMIT;

DROP USER pfc_DWH CASCADE;
COMMIT;
CREATE USER pfc_DWH
	IDENTIFIED BY dwh
	DEFAULT TABLESPACE TS_DWH
	QUOTA UNLIMITED ON TS_DWH
	TEMPORARY TABLESPACE temp
	QUOTA 0 ON users;
COMMIT;

GRANT CREATE SESSION
      , CREATE TABLE
      , CREATE TRIGGER
      , CREATE SEQUENCE 
TO pfc_DWH;

GRANT CREATE PROCEDURE TO pfc_DWH;
GRANT CREATE SYNONYM TO pfc_DWH;
COMMIT;

spool off
exit

